#ifndef SAVE_TIME_H
#define SAVE_TIME_H
#include "main.h"
#include "EEPROM.h"
#include "Irrigation.h"

// 在头文件中声明


// 直排模式时间参数地址
#define TIME_ADDR_DIRECT_PUMP_ON        0x00
#define TIME_ADDR_DIRECT_PUMP_OFF       0x04
#define TIME_ADDR_DIRECT_FAN_ON         0x08
#define TIME_ADDR_DIRECT_FAN_OFF        0x0C
#define TIME_ADDR_DIRECT_LOW_FAN_ON     0x10
#define TIME_ADDR_DIRECT_LOW_FAN_OFF    0x14
#define TIME_ADDR_DIRECT_FIRST_LOW_ON   0x18
#define TIME_ADDR_DIRECT_FIRST_LOW_OFF  0x1C

// 冲厕模式时间参数地址
#define TIME_ADDR_FLUSH_PUMP_ON         0x20
#define TIME_ADDR_FLUSH_PUMP_OFF        0x24
#define TIME_ADDR_FLUSH_FAN_ON          0x28
#define TIME_ADDR_FLUSH_FAN_OFF         0x2C
#define TIME_ADDR_FLUSH_LOW_FAN_ON      0x30
#define TIME_ADDR_FLUSH_LOW_FAN_OFF     0x34
#define TIME_ADDR_FLUSH_FIRST_LOW_ON    0x38
#define TIME_ADDR_FLUSH_FIRST_LOW_OFF   0x3C

// 灌溉模式时间参数地址
#define TIME_ADDR_IRRIG_PUMP_ON         0x40
#define TIME_ADDR_IRRIG_PUMP_OFF        0x44
#define TIME_ADDR_IRRIG_FAN_ON          0x48
#define TIME_ADDR_IRRIG_FAN_OFF         0x4C
#define TIME_ADDR_IRRIG_LOW_FAN_ON      0x50
#define TIME_ADDR_IRRIG_LOW_FAN_OFF     0x54
#define TIME_ADDR_IRRIG_FIRST_LOW_ON    0x58
#define TIME_ADDR_IRRIG_FIRST_LOW_OFF   0x5C

void Time_Save(void);
void Time_Load(void);

#endif



