#include "Ozone.h"

// Ʊ
uint8_t ozone_running = 0;         // Ĭϲ
uint32_t ozone_timer = 0;          // ʱ
uint32_t OZONE_ON_TIME = 1;        // 1
uint32_t OZONE_OFF_TIME = 1;       // ֹͣ1

void Save_Ozone_Time_To_EEPROM(uint32_t on_time, uint32_t off_time) // 
{
    Save_Float_To_EEPROM(OZONE_ON_TIME_ADDR, (float)on_time);  // ʱ
    Save_Float_To_EEPROM(OZONE_OFF_TIME_ADDR, (float)off_time); // ֹͣʱ
    Inf_AT24C02_WriteByte(OZONE_FLAG_ADDR, OZONE_FLAG_VAL); // ־
}

// EEPROMȡʱOZENE_FLAG_ADDR
void Load_Ozone_Time_From_EEPROM(void)
{
    uint8_t flag = Inf_AT24C02_ReadByte(OZONE_FLAG_ADDR);
    
    if(flag == OZONE_FLAG_VAL)
    {
        // ȡʱ
        OZONE_ON_TIME = (uint32_t)Read_Float_From_EEPROM(OZONE_ON_TIME_ADDR);
        OZONE_OFF_TIME = (uint32_t)Read_Float_From_EEPROM(OZONE_OFF_TIME_ADDR);
    }
    else
    {
        // EEPROMûЧݣʹĬֵ
        Save_Ozone_Time_To_EEPROM(OZONE_ON_TIME, OZONE_OFF_TIME);
    }
}
void Ozone_Init(void)
{
    Load_Ozone_Time_From_EEPROM();
    ozone_running = 1;  // ϵֱ
    ozone_timer = 0;    // ʼʱ
    Ozone_Control(1);   // ʼ״ֱ̬ӿ
   // printf("Ozone Init OK, starting immediately\n");
}

void Ozone_Control_Update(void)
{
    if(ozone_running)
    {
        // 1ӿ1ӹص߼
        if(ozone_timer <= OZONE_ON_TIME)
        {
            Ozone_Control(1);  // ֱӿƣҪм
         //   printf(": %d\n", ozone_timer);
        }
        else if(ozone_timer <= (OZONE_ON_TIME + OZONE_OFF_TIME))
        {
            Ozone_Control(0);
         //   printf("ͣ: %d\n", ozone_timer);
        }
        else
        {
            ozone_timer = 0;  // üʱʼѭ
            Ozone_Control(1);
         //   printf("ʼѭ\n");
        }
    }
    else
    {
        // Զ̿ƹرʱֹر״̬
        Ozone_Control(0);
       // printf("ѹر(Զ̿)\n");
    }
}


